/*!
 * KoliBri - The accessible HTML-Standard
 */
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const index=require("./index-cb5cbda1.js"),ariaCurrentService=require("./ariaCurrentService-53afa476.js"),events=require("./events-221fcb43.js"),dev_utils=require("./dev.utils-17f58b75.js"),componentNames=require("./component-names-2c750b1b.js"),i18n=require("./i18n-5f0ed6ed.js"),accessAndShortKey=require("./access-and-short-key-6155af7d.js"),prop_validators=require("./prop.validators-3c86f8eb.js"),href=require("./href-c14d2c3e.js"),reuse=require("./reuse-8cfefa9b.js"),buttonVariant=require("./button-variant-10ad2503.js"),customClass=require("./custom-class-1bd0519a.js"),disabled=require("./disabled-0ee19649.js"),hideLabel=require("./hide-label-a9a94f19.js"),icons=require("./icons-cfdc392f.js"),label=require("./label-3ce275fe.js"),tooltipAlign=require("./tooltip-align-5aee86e8.js");require("./dev.utils-58fde089.js"),require("./i18n-3219485c.js"),require("./index-c77a4142.js"),require("./common-1ab929ac.js"),require("./align-a9f24187.js");const ariaCurrentValuePropTypeOptions=["date","location","page","step","time","true","false"],validateAriaCurrentValue=(e,t)=>{prop_validators.watchValidator(e,"_ariaCurrentValue",(e=>"string"==typeof e&&ariaCurrentValuePropTypeOptions.includes(e)),new Set([`AriaCurrentValue {${ariaCurrentValuePropTypeOptions.join(", ")}`]),t,{defaultValue:"page"})},validateAriaOwns=(e,t)=>{prop_validators.watchString(e,"_ariaOwns",t,{defaultValue:void 0})},validateDownload=(e,t)=>{prop_validators.watchString(e,"_download",t)},validateLinkCallbacks=(e,t)=>{"object"==typeof t&&"function"==typeof(null==t?void 0:t.onClick)&&(e.state=Object.assign(Object.assign({},e.state),{_on:t}))},validateLinkTarget=(e,t)=>{prop_validators.watchString(e,"_target",t)},KolLinkWc=class{constructor(e){index.registerInstance(this,e),this.internalDescriptionById=dev_utils.nonce(),this.catchRef=e=>{this.anchorRef=e},this.onClick=e=>{var t,a;!0===this.state._disabled?events.preventDefaultAndStopPropagation(e):"function"==typeof(null===(t=this.state._on)||void 0===t?void 0:t.onClick)&&(e.preventDefault(),e.stopPropagation(),prop_validators.setEventTarget(e,this.anchorRef),null===(a=this.state._on)||void 0===a||a.onClick(e,this.state._href))},this.getRenderValues=()=>{const e="string"==typeof this.state._target&&"_self"!==this.state._target,t={href:"string"==typeof this.state._href&&this.state._href.length>0?this.state._href:"javascript:void(0);",target:"string"==typeof this.state._target&&this.state._target.length>0?this.state._target:void 0,rel:e?"noopener":void 0,download:"string"==typeof this.state._download?this.state._download:void 0};return!0!==this.state._hideLabel||this.state._label||prop_validators.devHint("[KolLink] An aria-label must be set when _hide-label is set."),{isExternal:e,tagAttrs:t}},this._accessKey=void 0,this._ariaCurrentValue=void 0,this._ariaDescription=void 0,this._ariaExpanded=void 0,this._ariaOwns=void 0,this._customClass=void 0,this._disabled=!1,this._download=void 0,this._hideLabel=!1,this._href=void 0,this._icons=void 0,this._label=void 0,this._on=void 0,this._role=void 0,this._shortKey=void 0,this._tabIndex=void 0,this._target=void 0,this._tooltipAlign="right",this._variant="normal",this.state={_ariaCurrentValue:"page",_href:"",_icons:{}}}async kolFocus(){var e;null===(e=this.anchorRef)||void 0===e||e.focus()}render(){var e,t;const{isExternal:a,tagAttrs:i}=this.getRenderValues(),s=reuse.showExpertSlot(this.state._label),l=Boolean(null===(t=null===(e=this.state._ariaDescription)||void 0===e?void 0:e.trim())||void 0===t?void 0:t.length);return index.h(index.Host,{key:"1d30bedcd820dec1c26c0eff106acc80bedb5cb3",class:"kol-link-wc"},index.h("a",Object.assign({key:"efc2b3393b67b4744cec4ea94b95014324d899f3",ref:this.catchRef},i,{accessKey:this.state._accessKey,"aria-current":this.state._ariaCurrent,"aria-describedby":l?this.internalDescriptionById:void 0,"aria-disabled":this.state._disabled?"true":void 0,"aria-expanded":"boolean"==typeof this.state._ariaExpanded?String(this.state._ariaExpanded):void 0,"aria-owns":this.state._ariaOwns,"aria-label":this.state._hideLabel&&"string"==typeof this.state._label?`${this.state._label}${a?` (${i18n.translate("kol-open-link-in-tab")})`:""}`:void 0,class:{disabled:!0===this.state._disabled,"external-link":a,"hide-label":!0===this.state._hideLabel,[this.state._variant]:"custom"!==this.state._variant,[this.state._customClass]:"custom"===this.state._variant&&"string"==typeof this.state._customClass&&this.state._customClass.length>0}},this.state._on,{onClick:this.onClick,onKeyPress:this.onClick,role:this.state._role,tabIndex:this.state._disabled?-1:this.state._tabIndex}),index.h(componentNames.KolSpanWcTag,{key:"02c28b7d44741668ee5847e454769195810a0958",_badgeText:this.state._accessKey||this.state._shortKey,_icons:this.state._icons,_hideLabel:this.state._hideLabel,_label:s?"":this.state._label||this.state._href},index.h("slot",{key:"14536938fdd95503bdfdc0bec1e56221a6e075f7",name:"expert",slot:"expert"})),a&&index.h(componentNames.KolIconTag,{key:"6624f9d9590bedd38e696d322f988a7ab0d0a6e6",class:"external-link-icon",_label:this.state._hideLabel?"":i18n.translate("kol-open-link-in-tab"),_icons:"codicon codicon-link-external","aria-hidden":this.state._hideLabel})),index.h(componentNames.KolTooltipWcTag,{key:"c4aea7ed08c840b8352626122c7f5a2c44dbe01a","aria-hidden":"true",hidden:s||!this.state._hideLabel,_badgeText:this.state._accessKey||this.state._shortKey,_align:this.state._tooltipAlign,_label:this.state._label||this.state._href}),l&&index.h("span",{key:"c2481878f8b0801390a63af0f33ce30ed9024f5e",class:"visually-hidden",id:this.internalDescriptionById},this.state._ariaDescription))}validateAccessKey(e){accessAndShortKey.validateAccessKey(this,e),accessAndShortKey.validateAccessAndShortKey(e,this._shortKey)}validateAriaCurrentValue(e){validateAriaCurrentValue(this,e)}validateAriaDescription(e){buttonVariant.validateAriaDescription(this,e)}validateAriaExpanded(e){buttonVariant.validateAriaExpanded(this,e)}validateAriaOwns(e){validateAriaOwns(this,e)}validateCustomClass(e){customClass.validateCustomClass(this,e)}validateDisabled(e){disabled.validateDisabled(this,e)}validateDownload(e){validateDownload(this,e)}validateHideLabel(e){hideLabel.validateHideLabel(this,e)}validateHref(e){href.validateHref(this,e,{required:!0})}validateIcons(e){icons.validateIcons(this,e)}validateLabel(e){label.validateLabelWithExpertSlot(this,e)}validateOn(e){validateLinkCallbacks(this,e)}validateRole(e){buttonVariant.validateAlternativeButtonLinkRole(this,e)}validateShortKey(e){accessAndShortKey.validateShortKey(this,e),accessAndShortKey.validateAccessAndShortKey(this._accessKey,e)}validateTabIndex(e){accessAndShortKey.validateTabIndex(this,e)}validateTarget(e){validateLinkTarget(this,e)}validateTooltipAlign(e){tooltipAlign.validateTooltipAlign(this,e)}validateVariant(e){buttonVariant.validateButtonVariant(this,e)}componentWillLoad(){this.validateAccessKey(this._accessKey),this.validateAriaCurrentValue(this._ariaCurrentValue),this.validateAriaDescription(this._ariaDescription),this.validateAriaExpanded(this._ariaExpanded),this.validateAriaOwns(this._ariaOwns),this.validateCustomClass(this._customClass),this.validateDisabled(this._disabled),this.validateDownload(this._download),this.validateHideLabel(this._hideLabel),this.validateHref(this._href),this.validateIcons(this._icons),this.validateLabel(this._label),this.validateOn(this._on),this.validateRole(this._role),this.validateShortKey(this._shortKey),this.validateTabIndex(this._tabIndex),this.validateTarget(this._target),this.validateTooltipAlign(this._tooltipAlign),this.validateVariant(this._variant),this.unsubscribeOnLocationChange=ariaCurrentService.onLocationChange((e=>{this.state._ariaCurrent=e===this.state._href?this.state._ariaCurrentValue:void 0})),accessAndShortKey.validateAccessAndShortKey(this._accessKey,this._shortKey)}disconnectedCallback(){this.unsubscribeOnLocationChange&&this.unsubscribeOnLocationChange()}static get watchers(){return{_accessKey:["validateAccessKey"],_ariaCurrentValue:["validateAriaCurrentValue"],_ariaDescription:["validateAriaDescription"],_ariaExpanded:["validateAriaExpanded"],_ariaOwns:["validateAriaOwns"],_customClass:["validateCustomClass"],_disabled:["validateDisabled"],_download:["validateDownload"],_hideLabel:["validateHideLabel"],_href:["validateHref"],_icons:["validateIcons"],_label:["validateLabel"],_on:["validateOn"],_role:["validateRole"],_shortKey:["validateShortKey"],_tabIndex:["validateTabIndex"],_target:["validateTarget"],_tooltipAlign:["validateTooltipAlign"],_variant:["validateVariant"]}}};exports.kol_link_wc=KolLinkWc;